#include <iostream>
#include "../../include/SIXDOM_Parser/xerces/SIXDOM_Parser.h"
#include "../../include/SIXDOM/TreeWalker.h"
#include "../../include/SIXML/SIXML.h"

#define DOWN 1
#define HORIZONTAL 2
#define UP 3

using namespace std;
using namespace SiXML;

void process_mem_usage(double & vm_usage);
TreeWalker * myWalker;

#define DOWN 1
#define HORIZONTAL 2
#define UP 3

void traverse(SDOM_Node * node) {
        int direction = DOWN;
        TreeWalker * treewalker = new TreeWalker(node);
        int nullNode = -1;
        long int count = 0;
	bool done = false;
        while (!done) {
                switch(direction) {
                case DOWN:
                        if (treewalker->getFirstChild() != NULL) {
				if (treewalker->getCurrentNode()->getNodeType() == ELEMENT)  
	                              count = count + 1;
                        }
                        else {
                                direction = HORIZONTAL;
                        }
                break;
                case HORIZONTAL:
                        if (treewalker->getNextSibling() != NULL) {
                                direction = DOWN;
				if (treewalker->getCurrentNode()->getNodeType() == ELEMENT)
                                	count = count + 1;
                        } else {
                                direction = UP;
                        }
                break;
                case UP:
                        if (treewalker->getParentNode() == NULL) done = true;
                        direction = HORIZONTAL;
                break;
                }
        }       
	delete treewalker; // free treewalker memory
        printf("Element Nodes: %ld\n", count);
}


int main(int arc, char * argv[]) {
	if (arc != 2) {
		cout << "Usage: " << argv[0] << " <xml file>" << endl;
		return -1;
	}
	double start_mem;
	process_mem_usage(start_mem);

   	char * xmlfile = argv[1];
	SDOM_Document * doc = (SDOM_Document *)parse_file(xmlfile);

	double end_mem;
	process_mem_usage(end_mem);

	cout << "Memory Usage: " << end_mem-start_mem << endl;

	traverse(doc);
	
	// release memory used by SIXDOM
	SucTree::release();
	doc->release();

	return 0;
}

// Display memory usage (LINUX SPECIFIC)
void process_mem_usage(double& vm_usage)
{
  using std::ios_base;
  using std::ifstream;
  using std::string;

  vm_usage     = 0.0;
  //
  ifstream stat_stream("/proc/self/stat",ios_base::in);

  // dummy vars for leading entries in stat that we don't care about
  //
  string pid, comm, state, ppid, pgrp, session, tty_nr;
  string tpgid, flags, cminflt, cmajflt;
  string utime, stime, cutime, cstime, priority, nice;
  string O, itrealvalue, starttime;

  // the two fields we want
  //
  unsigned long vsize;
  long rss;
  unsigned long majflt;
  unsigned long minflt;

  stat_stream >> pid >> comm >> state >> ppid >> pgrp >> session >> tty_nr
              >> tpgid >> flags >> minflt >> cminflt >> majflt >> cmajflt
              >> utime >> stime >> cutime >> cstime >> priority >> nice
              >> O >> itrealvalue >> starttime >> vsize >> rss; // don't care about the rest

  long page_size_kb = sysconf(_SC_PAGE_SIZE) / 1024; // in case x86-64 is configured to use 2MB pages
  vm_usage     = vsize / 1024.0;

}
