import java.io.*;
import java.text.DecimalFormat;

public class SIXDOM_Test{

	//attributes
	int check=0;
	public static int repCount;
	public static int option;
	public static TreeWalker myWalker;
	public static SDOM_Node myNode;
	public static SDOM_Node origNode;	
	public static SDOM_Node lastNode;	
	public static SDOM_NamedNodeMap namedNodeMap;
	public static SDOM_Node docNode;	
	public static int myNodeCount=0;
	public static int myTextCount=0;
	public static int myElemCount=0;

	static {
		System.loadLibrary("SIXDOM_XERCES_java");
	}
	//main
	public static void main (String []args){
		if (args.length != 1)
			{
				System.out.println("Usage: ./example <xml file>");
				return;
			}
		//time before parsing
		long startTimeBefParsing = System.currentTimeMillis( );
		//print virtual and resident memory before parse
		printMemory();
		//parse file
		SDOM_Node docNode= SIXDOM_XERCES.parse_file(args[0]);
		myNode=docNode;

		//time after parsing
		long endTimeAftParsing = System.currentTimeMillis( );
		long elapsedTime=endTimeAftParsing-startTimeBefParsing;
		System.out.println("Parse Time:"+elapsedTime);

		//treeWalker
		myWalker= new TreeWalker(docNode);
		//TestHarness experiments		
		long start= System.currentTimeMillis();
		//print virtual and resident memory after parse and before traversal
		printMemory();
		DOM_Traversal();

		long end= System.currentTimeMillis();
		//print number of nodes	
		System.out.println("No of Nodes: "+myNodeCount);
		System.out.println("No of Elements: "+myElemCount);
		System.out.println("No of TextNodes: "+myTextCount);
		System.out.println("Traversal Runtime: "+(end-start)+" ms");
		//print virtual and resident memory after traversal		
		printMemory();		
	}// end main	


	public static final int DOWN = 1;
	public static final int HORIZONTAL = 2;
	public static final int UP = 3;

	public static void DOM_Traversal(){

		int direction = DOWN;
		myNodeCount = 1;
		myElemCount = 0;
		boolean end = false;
		SDOM_Node current;
	
		while (!end) {
			switch (direction) {
			case DOWN:
				current = myWalker.getFirstChild();
				if (current != null) {
					if (current.getNodeType() == 1)
						myElemCount ++;
					myNodeCount ++;
				}
				else {
					direction = HORIZONTAL;
				}
				break;
			case HORIZONTAL:
				current = myWalker.getNextSibling();
				if (current != null) {
					if (current.getNodeType() == 1)
						myElemCount ++;
					direction = DOWN;
					myNodeCount ++;
				} else {
					direction = UP;
				}
				break;

			case UP:
				current = myWalker.getParentNode();
				if (current != null) {
					direction = HORIZONTAL;
				}
				else
					end = true;
				break;
			};
		}
		
	}//DOM_traversal

	public static void printMemory(){
		try { 
 			//file inputstream
			FileInputStream fstream = new FileInputStream("/proc/self/stat");
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine = null;
			double VM=0;
			double RES=0;
			long page_size_kb=4;
			strLine = br.readLine();	
				int i,j,counter=0;
				String m[]=strLine.split(" ");
			VM=Double.parseDouble(m[22])/1024;
			RES=Double.parseDouble(m[23])*page_size_kb;

			 DecimalFormat df = new DecimalFormat("#.##");

			System.out.println("VM: " + df.format(VM) + " RES: " + df.format(RES));
		}
		catch(IOException e){}
	}//end printMemory
}//end class
