/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#ifndef MYVECTOR_H_
#define MYVECTOR_H_

#include <iostream>


template <typename T>

class MyVector{

public:
  

  MyVector():size1(0),cap(1){
    data= new T[cap];
  }

  MyVector(long int i):size1(0),cap(i){
    data= new T[cap];
  }
  
  ~MyVector(){
    delete [] data;
  }
  
  void push_back(T val){
    if(size1<cap){
      data[size1]=val;
      size1++;
    }
    else{
      T* newArr = new T[cap*2];
      for(long int i=0;i<size1;i++){
	newArr[i]=data[i];
      }
      delete [] data;
      cap*=2;
      data=newArr;
   
      data[size1]=val;
      size1++;
    }
  }


 void push_back(const T * val, long int len){
   for(long int i=0;i<len;i++){
     push_back(val[i]);	
   }
  }

  void pop_back(){
    if(size1>0)
      size1--;
  }

 void pop_back(long int count){
   if((size1-count)>=0)
     size1-=count;
  }
  
  T at(long int i){
    if(i<size1 && i>=0)
      return data[i];
    else{
      return data[0];
	}
  }

  void resize(long int nSize){
    if(nSize>=0){
      if(nSize>cap){
	T* newArr = new T[nSize];
	for(long int i=0;i<size1;i++){
	  newArr[i]=data[i];
	}
	delete [] data;
	cap*=2;
	data=newArr;
      }
      size1=nSize;
    }
  }

  void clear(){
    delete [] data;
    cap=1;
    size1=0;
    data = new T[cap];
  }

  T *getData(){
    T * newData= new T[size1];
    for(long int i=0;i<size1;i++){
      newData[i]=data[i];
    }
    return newData;
  }
  T * getData2(){
    return data;
  }

  long int size(){
    return size1;
  }




private:
  T * data;
  long int size1;
  long int cap;
};
#endif
