/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#ifndef __MYPAREN_H
#define __MYPAREN_H

#include "../myUtils.h"
#include "../MyVector.h"
#include <iostream>
using namespace std;




class MyRank{

public:
	MyRank(unsigned char *bv, int l):len(l){
		MyVector<int> rankV0= MyVector<int>(100);
			
        	for(int i=0, pos=7,j=0, ranki=0;i< len;i++,pos--){

			if(((bv[j]>>pos)&1) == 0){
				ranki++;
			}
			else							
			rankV0.push_back(ranki);
    		       if(pos==0){
      			pos=8;
      			j++;
    		       } 	
		}
		
		rankBV0 = rankV0.getData();
	
		rankV0.clear();
	}
	int rank0(int i){
		if(i<len)		
			return rankBV0[i];
		else return -1;
	}
	int rank1(int i){
		if(i<len)	
			return i-rankBV0[i];
		else
			return -1;	
	}
private:
	int * rankBV0;
	int len;
};


class MySelect{

public:
	MySelect(unsigned char *bv, int l):len(l){

		MyVector<int> selectV0= MyVector<int>(100);
		MyVector<int> selectV1= MyVector<int>(100);
		MyVector<int> rankV0= MyVector<int>(100);
        	for(int i=0, pos=7,j=0, ranki=0;i< len;i++,pos--){

			if(((bv[j]>>pos)&1) == 0){
				ranki++;
				selectV0.push_back(i);
			}
			else			
				selectV1.push_back(i);
			rankV0.push_back(ranki);
    		       if(pos==0){
      			pos=8;
      			j++;
    		       } 	
		}
		//cout<<endl;//REMOVE printline statement
		selectBV0 = selectV0.getData();
		selectBV1 = selectV1.getData();
		rankBV0 = rankV0.getData();
	
		selectV0.clear();
		selectV1.clear();
		rankV0.clear();
	}

	int select0(int i){
	
		if(i>=s1Len)
			return selectBV0[i];
		else
			return -1;
	}
	int select1(int i){

		if(i>=s1Len)
			return selectBV0[i];
		else
			return -1;
	}
	int rank0(int i){
		i--;

		if(i<len)		
			return rankBV0[i];
		else return -1;
	}
	int rank1(int i){
		i--;
		if(i<len)	
			return i-rankBV0[i];
		else
			return -1;	
	}
	int getInternal(int i){		
		if(i==1){
			return (rank0(i)^1);
		}
		if(rank0(i) == rank0(i-1)){
		  return 1;
		}
		else
		  return 0;
	}

private:
	int * selectBV0;
	int * selectBV1;
	int * rankBV0;
	int len;
	int s1Len, s0Len;

};

class MyParen{

public:
  MyParen(){}
  MyParen(unsigned char *bv, int l);
  //Paren(tPAREN *newBV){m_bv=newBV;}
  ~MyParen(){
    delete m_bv1;
  }

  unsigned int rank0(unsigned int n){
    return rankBV->rank0(n);
  }


  inline int getNodePosition(int node_n){
    return rank0(node_n);
  }
  
  inline nodeValue FindClose1(nodeValue openpdn)
  {
    nodeValue closepdn=nullNode;
    closepdn.node_2n = FindClose(openpdn.node_2n);
	  
    if ( closepdn.node_2n!=-1 )
      {
	closepdn.node_n=openpdn.node_n + 
	  (closepdn.node_2n-openpdn.node_2n)/2;
      }
    else
      {
	closepdn.node_n = 0;
	closepdn.node_2n = 0;
      }
    
    return closepdn;
  } 
  
  
  inline nodeValue FindEnclose1(nodeValue childpdn)
  {
    nodeValue enclosepdn=nullNode;
    enclosepdn.node_2n = FindEnclose(childpdn.node_2n);
    if ( enclosepdn.node_2n!=-1 )
      {
	enclosepdn.node_n = childpdn.node_n -
	  (childpdn.node_2n-enclosepdn.node_2n+1)/2;
      }
    else 
      {
	enclosepdn.node_n = 0;
	enclosepdn.node_2n = 0;
      }
    return enclosepdn;
  }	
  
  
  inline nodeValue FindOpen1(nodeValue closepdn)
  {
    nodeValue openpdn;
    openpdn.node_2n = FindOpen(closepdn.node_2n);
    
    if ( openpdn.node_2n!=-1 )
      {
	openpdn.node_n = closepdn.node_n -
	  (closepdn.node_2n-openpdn.node_2n)/2;
      }
    else 
      {
	openpdn.node_n = 0;
	openpdn.node_2n = 0;
      }
    return openpdn;
  }


  unsigned int FindEnclose(unsigned int);
  unsigned int FindOpen(unsigned int);
  unsigned int FindClose(unsigned int);
  unsigned int getNextOpen(unsigned int);
  unsigned int getPreviousOpen(unsigned int);
  unsigned int get(unsigned int);


 bool hasChildNodes(int NodeOpen);
  bool hasChildren(nodeValue i);
  int descendants(nodeValue i){return 0;} // new added method
  
  nodeValue parent(nodeValue i);
  nodeValue child(nodeValue x, int i);
  nodeValue firstChild(nodeValue i);
  nodeValue lastChild(nodeValue i);
  nodeValue nextSibling(nodeValue i);
  nodeValue previousSibling(nodeValue i);
  nodeValue nextNode(nodeValue i);
  nodeValue previousNode(nodeValue i);
  
  double spaceUsage(){return 0;}

 struct PAREN{
    int match;
    int enclose;
  } itemi;
private:
  PAREN * m_bv1;
  nodeValue nullNode;
  MyRank * rankBV;

  int len;
};
#endif
