//Author O'Neil Delpratt

//October 2006
//major modification made 28th June 2007


#ifndef TEXTDS_H_
#define TEXTDS_H_

//remove comments
#include "../PrefixSumDS/SuccinctPrefixSum.h"
//#include "../PrefixSumDS/ExplicitPrefixSum.h"
#include "MyVector.h"

#ifdef SIX_COMP 
	#include "NTextDSComp.h"
#else
	#include "NTextDS.h"
#endif

using namespace std;

class TextDS{
public:
NTextDS * textDS;

void addTextDS(NTextDS * t) {
	textDS = t;
}

//default constructor
  TextDS()throw(bad_alloc){}
  TextDS(unsigned int * arr, int l, unsigned char* data,int l2)throw(bad_alloc);
  TextDS(unsigned int * arr, int l1, unsigned char* data, int l2,unsigned int * att_array_offset, int att_off_length,unsigned char* data2,int aLength)throw(bad_alloc);
TextDS(unsigned int, unsigned int * att_array_offset, int att_off_length,MyVector<unsigned char*>* attrData,int aLength)throw(bad_alloc);
  TextDS(const TextDS& x)throw(bad_alloc){
    tNodeCount=x.tNodeCount;
    aNodeCount=x.aNodeCount;
    prefixSumDS=x.prefixSumDS;
    attr_prefixSumDS=x.attr_prefixSumDS; 
    data_length=x.data_length;
    data_Attr_length=x.data_Attr_length;
    nullOffset=x.nullOffset;
    for(int i=0;i<(data_Attr_length+data_length);i++){
      text_data[i]=x.text_data[i];
    }
  }
  
  ~TextDS()throw(){
    delete attr_prefixSumDS;
	delete [] text_data;
	delete textDS;
  }  
  //start counting from 1
  inline tOffset getTextNodeOffset(int tNode){
    tOffset myOffset;
    myOffset.start=prefixSumDS->sum(tNode-1);
    myOffset.end=prefixSumDS->sum(tNode);
    return myOffset;
  }
  
  //start counting from 1
  inline tOffset getAttrNodeOffset(int aNode){

    // if(aNode<aNodeCount){
      tOffset myOffset;
      myOffset.start=attr_prefixSumDS->sum(aNode-1);
      myOffset.end=attr_prefixSumDS->sum(aNode);
      return myOffset;
      //}
      // else
      // return nullOffset;
}
  //NOTE - since the code modification this method needs redesigning   
  inline tOffset getTextNodeGroupOffset(int tStartNode, int tEndNode){
  
  if(tEndNode<tNodeCount){
    tOffset myOffset;
    
    myOffset.start=prefixSumDS->sum(tStartNode-1);
    myOffset.end=prefixSumDS->sum(tEndNode);
    return myOffset;
  }
  else
    return nullOffset;
}

  char* getTextNodeGroup(int tStartNode, int tEndNode){
    tNodeCount=tEndNode-tStartNode;  
    if(tNodeCount>0){
      tNodeCount--;
    int tStart=prefixSumDS->sum(tStartNode-1);
    int tEnd=prefixSumDS->sum(tEndNode);
    int totalLength=tEnd-tStart;
    char* newChars=new char[totalLength-tNodeCount];
    char* temp=text_data+tStart;
    for(int i=0,z=0;i<totalLength;i++){
      if(temp[i]!='\0'){
        newChars[z]=temp[i];
	z++;
      }
    }
    newChars[totalLength-tNodeCount]='\0';
    return newChars;
    }
  return NULL ;//original code - remove comment "";
}
  
  const char* getString(tOffset t);
    
  inline const char* getTextString(int val){
//      unsigned int start=prefixSumDS->sum(val-1);
//	  cout << "..." << textDS->getString(val-1) << "////" << text_data+start << "..." << endl;
      return textDS->getString(val-1);
  }
  
  //attr Nodes
  inline const char* getString(int attNum){
      unsigned int start=attr_prefixSumDS->sum(attNum-1);
      return text_data+start;
  }
   
  //new method to help getting of IDs (for attributes)
  inline const char* getStringByOffset(int offset){
      return text_data+(offset);
  }

  inline double logBase2(const double &x){
    return (double)((log (x))/(log (2.0)));
  }
  
  double spaceUsageT(){return (data_length*(sizeof(char)+4))+prefixSumDS->spaceUsage();}
  double spaceUsageA(){return (data_length*(sizeof(char)+4))+attr_prefixSumDS->spaceUsage();}
  double spaceUsage(){return spaceusage;}
  int getTextNodeCount(){return tNodeCount;}
  int getAttrNodeCount(){return aNodeCount;}
private:
  double spaceusage;
  int tNodeCount;
  int aNodeCount;
  int data_length;
  int data_Attr_length;
  tOffset nullOffset;
	
	//test code
  /* ExplicitPrefixSum *prefixSumDS;
  ExplicitPrefixSum *attr_prefixSumDS;
  */
	
	 //original code - remove comments below
  SuccinctPrefixSum *prefixSumDS;
  SuccinctPrefixSum *attr_prefixSumDS;

 char * text_data;
};
#endif
