/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */


#ifndef BITSTRING_H_
#define BITSTRING_H_

#include <iostream>
#include <math.h>
using namespace std;

typedef struct {unsigned int first; unsigned int second;} myBlock1;

class BitString{


public:
  BitString(){}
  
  
  BitString(unsigned int *arr, unsigned int *lengths, int num);
  BitString(unsigned int *arr1, unsigned int *lengths1,unsigned int *arr2, unsigned int *lengths2,int num);
  BitString(const BitString& bs)throw(bad_alloc){
    k=bs.k;
    strLength=bs.strLength;
    int arraySize=(strLength+7)/8;
    seq = new unsigned int[arraySize];
    for(int i=0;i<arraySize;i++){
      seq[i]=bs.seq[i];
    }
  }
  
  void Compact(unsigned int *arr,unsigned int *lengths,int k,int bit_length);
  
  void Compact_F(unsigned int *arr,unsigned int *lengths,int k,int bit_length);  
  void Compact_S(unsigned int *arr,unsigned int *lengths,int k,int bit_length); 
  
  ~BitString(){delete []seq;}
  
  int singleBit(unsigned int i);
  
       
  //reading bits from position 31 to 0
   unsigned int subString(unsigned int i, unsigned int j);
   
 //reading bits from position 31 to 0
 
   unsigned int subString3(unsigned int i, unsigned int j);
   
//reading bits from position 31 to 0
   unsigned int subString_F(unsigned int i, unsigned int j);

//reading bits from position 31 to 0
   unsigned int subString_S(unsigned int i, unsigned int j);

//reading bits from position 0 to 31
   unsigned int subString2(unsigned int i, unsigned int j);

//starting from bit 0 -> 31
//e.g. 11001001, getSuffixWord(4)= 11001

unsigned int getSuffixAlignWord(unsigned int i);
unsigned int getSuffixAlignWord_F(unsigned int i);
unsigned int getSuffixAlignWord_S(unsigned int i);

//starting from bit 0 -> 31
//e.g. 11001001, getPrefixWord(4)= 1001

unsigned int getPrefixAlignWord(unsigned int i);

unsigned int getPrefixAlignWord_F(unsigned int i);

unsigned int getPrefixAlignWord_S(unsigned int i);

//whole align word
unsigned int getWholeAlignWord(unsigned int i);

unsigned int getWholeAlignWord_F(unsigned int i);

unsigned int getWholeAlignWord_S(unsigned int i);
 
unsigned int getWholeWord(unsigned int i);

  //in bytes
  double spaceUsage(){
    return strLength;
  }

private:
  int k; 
  static const unsigned int lob,lob32,mask;
  unsigned int strLength;
  unsigned int *seq;
  myBlock1 *seq_dual;
};
#endif

