/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */
 
#ifndef SUCCINCTPREFIXSUM_H_
#define SUCCINCTPREFIXSUM_H_

#include "PrefixSum.h"
#include <math.h>
#include "../SuccinctDS/CFID.h"
#include "BitString.h"
#include <iostream>

#include <string.h>
using namespace std;
typedef CFID<CRank<Simple_block<64>,64>, 64> tFID2;



class SuccinctPrefixSum: public PrefixSum{
public:
  SuccinctPrefixSum(){}
  SuccinctPrefixSum(unsigned int *arr,unsigned int s);
  SuccinctPrefixSum(const SuccinctPrefixSum& psum)throw(bad_alloc){
    k=psum.k;
    f=psum.f;
    sigBits=psum.sigBits;
    bs=psum.bs; 
    theFID=psum.theFID; 
  }
  
	~SuccinctPrefixSum(){
		if (theFID != NULL)
			delete theFID;
		delete bs;
	}
  
  int getRemSize(){
    return remSize;
  }

      
  //reading from zero
unsigned int sum(int i);
  
  inline unsigned int sum_BV(int i);
    
  inline unsigned int select1(const int &i){
    return 0;
  }
  
  void encoder(unsigned int *arr);
  
  void createFID(unsigned char *eBytes){
    theFID = new tFID2( eBytes,(((1<<f)-1)+k+1),suppSelect0);
  }

  int remSize;
  
  double spaceUsage(){
    return 0;
  }
  
private: 
  int k,f, sigBits,number;
  BitString *bs;   //BitString
   tFID2 * theFID;
};
#endif

