/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Naila Rahman, Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#ifndef __CSIMPLEFID_H
#define __CSIMPLEFID_H

#include "utils.h"
#include "CRank.h"

typedef struct
{
	UINT A1;
	UBYTE A2[TPARAM];
}	A1A2_t;



template <UINT R1> class  CSimpleFID
{
public:
	static string name() { return string("CSimpleFID"); }
	CSimpleFID<R1>( const UINT * a1AddrList, const UINT n, const UINT n1);
	~CSimpleFID<R1>() {
		delete [] m_aA1A2;
		delete m_aA3;
	}

	UINT rank1( const UINT i );
	UINT select1( const UINT i );
	UINT pred1(UINT i, UINT * prev1);
	UINT succ1(UINT i, UINT * next1);

private:
	void BuildTableT1();
	void BuildTableT2();
	void BuildArrayA1A2(const UINT * aAddr1List, const UINT n1);
	void BuildArrayA3(const UINT n, const UINT n1);
	A1A2_t* m_aA1A2;
	CRank<Simple_block<R1>, R1> * m_aA3;
	UINT R1_LG;
	UINT    m_n;
	UINT    m_n1;
#ifdef SIMPLEFID_USE_TABLES
	static UINT m_fFirst;
	static UINT m_aT1[ 1 << ((lgRB1+1) * TPARAM ) ];
	static UINT m_aT2[ 1 << ((lgRB1+1) * TPARAM ) ][TPARAM];
#endif
};

#endif // __CSIMPLEFID_H

