/* Copyright Feb 2013 O'Neil Delpratt, Stelios Joannou and Naila Rahman, Rajeev Raman
 * University of Leicester
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#ifndef __CUNARYFID_H
#define __CUNARYFID_H

#include "utils.h"
#include "buffer.h"
#include "CFID.h"


template <class TFID> class  CUnaryFID : public TFID
{
public:
	static string name() { return string("CUnaryFID"); }
	CUnaryFID<TFID>( const UINT * a1AddrList, const UINT n, const UINT n1);
	UINT rank1( const UINT i );
	UINT select1( const UINT i );
	UINT rank1select1(UINT i, UINT * prev1);
	

private:
	void BuildFlagVector(const UINT * a1AddrList, const UINT n, const UINT n1);
	UBYTE      * m_CompRemainders;
};


#endif // __CUNARYFID_H

